/* mp3 live server version 0.02 */
/* Copyright Scott Manley 1997 */
/* This Software is protected under the terms of the Gnu Public License */
/* All code is original*/

#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netdb.h>
#include <netinet/in.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <netdb.h>
#include <arpa/inet.h>   
#include <sched.h>       

/* Soundcard support */
#define SOUNDCARD_SUPPORT

/* Default port */
#define PORT 3223

#define S_DELAY 0
#define S_NDELAY 1

#define S_RESET 0
#define S_SET 1
#define S_NAMLEN 64

#define BITRATE 24000
#define BYTERATE (BITRATE/8)

#define MP_BUFF_SIZE 4096  /* make sure this is large enough */

/* How far from the end of the live stream can we rewind */
#define REW_BYTES BYTERATE

/* how long to sleep if we're waiitng for live file to be updated */
#define SHORT_SLEEP (200000*BYTERATE/MP_BUFF_SIZE)

/* number of seconds between lag reports */
#define LAG_TIME 30

#define SAMPLE_RATE 22050


/* some socket stuff */
typedef struct{
    struct sockaddr_in sin;
    int sinlen;
    int bindflag;
    int sd;
} sckt;


/* general server stuff */
typedef struct{
  int serv_port;
  int mnt_port;
  int server;             /* are we a server or a reflector */
  char *reflector;
  int reflector_port;
  char *mnt_pipe;         /* name of pipe for Maintenace process */
  char *snd_pipe;         /* name of pipe for sound processing */
  char *header_file;      /* name of file used to store header */
  char *live_file;        /* name of file for live data */
  char *log_file;         /* name of file for logging */
  int limit;              /* maximum no. of allowable subprocesses */
} config;


/* other functions */

void fatal(char *text);
int sserver(sckt *sp, int port, int sync);
int sclient(sckt *sp, char *name, int port);
sckt *sopen(void);
int sclose(sckt *sp);
int valid(unsigned long); 

void maintain_server(config conf);
void start_server(config conf);
void report(char *str,FILE *mnt);










